<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1authorization.html">authorization</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate.html">cblAuthDelegate</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_c_b_l_auth_delegate_8h_source.html">CBLAuthDelegate.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_inherit__map" id="alexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::AuthDelegateInterface" alt="" coords="5,5,253,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html" title="alexaClientSDK::registration\lManager::CustomerDataHandler" alt="" coords="22,68,236,107"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_coll__map" id="alexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::AuthDelegateInterface" alt="" coords="5,5,253,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html" title="alexaClientSDK::registration\lManager::CustomerDataHandler" alt="" coords="22,68,236,107"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a8d7b8505de39a1008ade4a3ef4bec812"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a8d7b8505de39a1008ade4a3ef4bec812">CBLAuthDelegate</a> (const <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a> &amp;rhs)=delete</td></tr>
<tr class="separator:a8d7b8505de39a1008ade4a3ef4bec812"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af91fa3fcdfebc49c0c4fbc192d1fa5d7"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#af91fa3fcdfebc49c0c4fbc192d1fa5d7">~CBLAuthDelegate</a> ()</td></tr>
<tr class="separator:af91fa3fcdfebc49c0c4fbc192d1fa5d7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1f95c62962c04b103c3b832f3dd51e8"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ae1f95c62962c04b103c3b832f3dd51e8">operator=</a> (const <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a> &amp;rhs)=delete</td></tr>
<tr class="separator:ae1f95c62962c04b103c3b832f3dd51e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">AuthDelegateInterface methods</div></td></tr>
<tr class="memitem:ae3b4c2dbdbc2bbb4ce098faa4f92fdc5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ae3b4c2dbdbc2bbb4ce098faa4f92fdc5">addAuthObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html">avsCommon::sdkInterfaces::AuthObserverInterface</a> &gt; observer) override</td></tr>
<tr class="separator:ae3b4c2dbdbc2bbb4ce098faa4f92fdc5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad9c4e36ecd1310564e2bcb0950e52b52"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ad9c4e36ecd1310564e2bcb0950e52b52">removeAuthObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html">avsCommon::sdkInterfaces::AuthObserverInterface</a> &gt; observer) override</td></tr>
<tr class="separator:ad9c4e36ecd1310564e2bcb0950e52b52"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6090364bb64d10192a562c93fb0a823d"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a6090364bb64d10192a562c93fb0a823d">getAuthToken</a> () override</td></tr>
<tr class="separator:a6090364bb64d10192a562c93fb0a823d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a633e5f9dd987fac530edf5fbb443ec3f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a633e5f9dd987fac530edf5fbb443ec3f">onAuthFailure</a> (const std::string &amp;token) override</td></tr>
<tr class="separator:a633e5f9dd987fac530edf5fbb443ec3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">CustomerDataHandler methods</div></td></tr>
<tr class="memitem:acde6f10ba3fb25419f66fdc7927c9bc0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#acde6f10ba3fb25419f66fdc7927c9bc0">clearData</a> () override</td></tr>
<tr class="separator:acde6f10ba3fb25419f66fdc7927c9bc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface</a></td></tr>
<tr class="memitem:ae2256b1de42b60b2a08500f45c6f3669 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#ae2256b1de42b60b2a08500f45c6f3669">~AuthDelegateInterface</a> ()=default</td></tr>
<tr class="separator:ae2256b1de42b60b2a08500f45c6f3669 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html">alexaClientSDK::registrationManager::CustomerDataHandler</a></td></tr>
<tr class="memitem:a2246fb7b5773b2d9643e880bde58acf9 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html#a2246fb7b5773b2d9643e880bde58acf9">CustomerDataHandler</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_manager.html">CustomerDataManager</a> &gt; customerDataManager)</td></tr>
<tr class="separator:a2246fb7b5773b2d9643e880bde58acf9 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a067f8855e7ac0c05fc190b6b2e8e2d19 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html#a067f8855e7ac0c05fc190b6b2e8e2d19">~CustomerDataHandler</a> ()</td></tr>
<tr class="separator:a067f8855e7ac0c05fc190b6b2e8e2d19 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a35a3aab6219b7d1d3ffa50b21726a3e7"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a35a3aab6219b7d1d3ffa50b21726a3e7">create</a> (const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">avsCommon::utils::configuration::ConfigurationNode</a> &amp;configuration, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_manager.html">registrationManager::CustomerDataManager</a> &gt; customerDataManager, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_storage_interface.html">CBLAuthDelegateStorageInterface</a> &gt; storage, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_requester_interface.html">CBLAuthRequesterInterface</a> &gt; authRequester, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html">avsCommon::utils::libcurlUtils::HttpPostInterface</a> &gt; httpPost=nullptr, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_device_info.html">avsCommon::utils::DeviceInfo</a> &gt; deviceInfo=nullptr)</td></tr>
<tr class="separator:a35a3aab6219b7d1d3ffa50b21726a3e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class=""><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a> provides an implementation of the <code>AuthDelegateInterface</code> using the Code-Based Linking authorization process. </p><dl class="section see"><dt>See also</dt><dd><a href="https://developer.amazon.com/docs/alexa-voice-service/code-based-linking-other-platforms.html">https://developer.amazon.com/docs/alexa-voice-service/code-based-linking-other-platforms.html</a> </dd></dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a8d7b8505de39a1008ade4a3ef4bec812"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8d7b8505de39a1008ade4a3ef4bec812">&#9670;&nbsp;</a></span>CBLAuthDelegate()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::CBLAuthDelegate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Deleted copy constructor</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rhs</td><td>The 'right hand side' to not copy. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="af91fa3fcdfebc49c0c4fbc192d1fa5d7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af91fa3fcdfebc49c0c4fbc192d1fa5d7">&#9670;&nbsp;</a></span>~CBLAuthDelegate()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::~CBLAuthDelegate </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Destructor </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ae3b4c2dbdbc2bbb4ce098faa4f92fdc5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae3b4c2dbdbc2bbb4ce098faa4f92fdc5">&#9670;&nbsp;</a></span>addAuthObserver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::addAuthObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html">avsCommon::sdkInterfaces::AuthObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Specify an object to observe changes to the authorization state of this AuthDelegate. During the call to this setter the observers onAuthStateChange() method will be called back with the current authorization state.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The object to observe this authorization state of this AuthDelegate. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#a4828a1a064ec6c1c1d9c2fefad5d5d0d">alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface</a>.</p>

</div>
</div>
<a id="acde6f10ba3fb25419f66fdc7927c9bc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acde6f10ba3fb25419f66fdc7927c9bc0">&#9670;&nbsp;</a></span>clearData()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::clearData </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Reset any internal state that may be associated with a particular user.</p>
<dl class="section warning"><dt>Warning</dt><dd>Object must succeed in deleting any customer data. </dd>
<dd>
This method is called while CustomerDataManager is in a locked state. Do not call or wait for any CustomerDataManager operation. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html#a36e0bb31b4187dbc04141aca7209f4c5">alexaClientSDK::registrationManager::CustomerDataHandler</a>.</p>

</div>
</div>
<a id="a35a3aab6219b7d1d3ffa50b21726a3e7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a35a3aab6219b7d1d3ffa50b21726a3e7">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a> &gt; alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::create </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">avsCommon::utils::configuration::ConfigurationNode</a> &amp;&#160;</td>
          <td class="paramname"><em>configuration</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_manager.html">registrationManager::CustomerDataManager</a> &gt;&#160;</td>
          <td class="paramname"><em>customerDataManager</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_storage_interface.html">CBLAuthDelegateStorageInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>storage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_requester_interface.html">CBLAuthRequesterInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>authRequester</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html">avsCommon::utils::libcurlUtils::HttpPostInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>httpPost</em> = <code>nullptr</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_device_info.html">avsCommon::utils::DeviceInfo</a> &gt;&#160;</td>
          <td class="paramname"><em>deviceInfo</em> = <code>nullptr</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Create a <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a>. This function cannot be called if: </p><ul>
<li>
AlexaClientSDKInit::initialize has not been called yet. </li>
<li>
After AlexaClientSDKInit::un-initialize has been called. </li>
</ul>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">configuration</td><td>The ConfigurationNode containing the configuration parameters for the new instance. </td></tr>
    <tr><td class="paramname">customerDataManager</td><td>The CustomerDataManager instance this instance should register with. </td></tr>
    <tr><td class="paramname">storage</td><td>The object used to persist the new <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a>'s state. </td></tr>
    <tr><td class="paramname">authRequester</td><td>Observer used to tell the user to browse to a URL and enter a 'user code'. </td></tr>
    <tr><td class="paramname">httpPost</td><td>Instance that implements HttpPostInterface. If nullptr, a default implementation. </td></tr>
    <tr><td class="paramname">deviceInfo</td><td>The deviceInfo instance. will be provided. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a6090364bb64d10192a562c93fb0a823d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6090364bb64d10192a562c93fb0a823d">&#9670;&nbsp;</a></span>getAuthToken()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::getAuthToken </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Get the current LWA authorization token.</p>
<dl class="section return"><dt>Returns</dt><dd>The current authorization token. The returned value will be empty if an authorization token has yet to be acquired or if the most recently acquired token has expired. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#a1fe1b7ac461f206358d5c7e7e82121f5">alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface</a>.</p>

</div>
</div>
<a id="a633e5f9dd987fac530edf5fbb443ec3f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a633e5f9dd987fac530edf5fbb443ec3f">&#9670;&nbsp;</a></span>onAuthFailure()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::onAuthFailure </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>token</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Receive notification that an operation using the specified auth token experienced an authorization failure.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">token</td><td>The token used to authorize the forbidden operation. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#a593db990b9dffa41a6d101be30c1ed70">alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface</a>.</p>

</div>
</div>
<a id="ae1f95c62962c04b103c3b832f3dd51e8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae1f95c62962c04b103c3b832f3dd51e8">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a>&amp; alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Deleted assignment operator</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rhs</td><td>The 'right hand side' to not copy. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad9c4e36ecd1310564e2bcb0950e52b52"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad9c4e36ecd1310564e2bcb0950e52b52">&#9670;&nbsp;</a></span>removeAuthObserver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::removeAuthObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html">avsCommon::sdkInterfaces::AuthObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Remove an observer</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to remove. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#acba7bf24a550d8009a0d9adbb72955b0">alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/SampleApp/Authorization/CBLAuthDelegate/include/CBLAuthDelegate/<a class="el" href="_c_b_l_auth_delegate_8h_source.html">CBLAuthDelegate.h</a></li>
<li>/workplace/avs-device-sdk/SampleApp/Authorization/CBLAuthDelegate/src/<a class="el" href="_c_b_l_auth_delegate_8cpp.html">CBLAuthDelegate.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
